%define anolis_release 1

%global scl gcc-toolset-10
BuildRequires: scl-utils-build

%{?scl:%scl_package autoconf}
%{!?scl:
 %global pkg_name %{name}
 %global _root_prefix %{_prefix}
 %global _root_datadir %{_datadir}
 %global _root_libdir %{_libdir}
}

Name:    %{?scl_prefix}autoconf
Summary: A GNU tool for automatically configuring source code
Version: 2.69
Release: %{anolis_release}%{?dist}
License: GPLv2+ and GFDL
URL: http://www.gnu.org/software/autoconf/

Source0:    http://ftpmirror.gnu.org/autoconf/autoconf-%{version}.tar.xz
Source1:    config.site
Source2:    autoconf-init.el

# Maintainer: nickc@redhat.com
# Web Page: https://sourceware.org/annobin/
# Watermark Protocol: https://fedoraproject.org/wiki/Toolchain/Watermark

ExcludeArch: loongarch64

#---------------------------------------------------------------------------------

%bcond_with check

Patch1:     autoconf-2.69-perl-5.22-autoscan.patch
# Backport: see RHEL-40719
Patch2:     0001-Port-AC_F77_LIBRARY_LDFLAGS-to-oneAPI-HPC-Toolkit.patch
Patch1001:     1001-Remove-docs-uncompatible.patch

BuildArch:  noarch
#---------------------------------------------------------------------------------

%{?scl:Requires:%scl_runtime}
## %{?scl:Requires:%scl_require_package %{scl} gcc}
%{?scl:BuildRequires:%scl_runtime}
%{?scl:BuildRequires:scl-utils-build}

## BuildRequires: %{?scl_prefix}gcc %{?scl_prefix}gcc-plugin-devel %{?scl_prefix}gcc-c++
%define gcc_for_autoconf %{?_scl_root}/usr/bin/gcc


# Make sure that the necessary sub-packages are built.

%if %{with gccplugin}
Requires: %{name}-plugin-gcc
%endif

%if %{with llvmplugin}
Requires: %{name}-plugin-llvm
%endif

%if %{with clangplugin}
Requires: %{name}-plugin-clang
%endif

# m4 >= 1.4.6 is required, >= 1.4.14 is recommended:
BuildRequires:      m4 >= 1.4.14
Requires:           m4 >= 1.4.14
%if %{with autoconf_enables_emacs}
Requires:           emacs-filesystem
BuildRequires:      emacs
%endif
# the filtering macros are currently in /etc/rpm/macros.perl:
BuildRequires:      perl-generators
BuildRequires:      perl-macros
BuildRequires:      perl(Data::Dumper)
# from f19, Text::ParseWords is not the part of 'perl' package
BuildRequires:      perl(Text::ParseWords)

BuildRequires:      gcc-toolset-10-build
BuildRequires:      scl-utils-build

# %%configure replaces config.guess/config.sub for us, which confuses autoconf
# build system and it produces empty man pages for those scripts if help2man is
# not installed
BuildRequires:      help2man

%if %{with check}
%if %{with autoconf_enables_optional_test}
# For extended testsuite coverage
BuildRequires:      gcc-gfortran
%if 0%{?fedora} >= 15
BuildRequires:      erlang
%endif
%endif
%endif

Requires(post):     /sbin/install-info
Requires(preun):    /sbin/install-info

# filter out bogus perl(Autom4te*) dependencies
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(Autom4te::
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}^perl\\(Autom4te::

Provides: %{_bindir}/autoconf
#---------------------------------------------------------------------------------

%description
GNU's Autoconf is a tool for configuring source code and Makefiles.
Using Autoconf, programmers can create portable and configurable
packages, since the person building the package is allowed to
specify various configuration options.

You should install Autoconf if you are developing software and
would like to create shell scripts that configure your source code
packages. If you are installing Autoconf, you will also need to
install the GNU m4 package.

Note that the Autoconf package is not required for the end-user who
may be configuring software with an Autoconf-generated script;
Autoconf is only required for the generation of the scripts, not
their use.

#---------------------------------------------------------------------------

%prep
%autosetup -p1 -n autoconf-%{version}


%build

export CFLAGS="$CFLAGS $RPM_OPT_FLAGS -I%{?_scl_root}/usr/include"
export LDFLAGS="$LD_FLAGS $RPM_LD_FLAGS -L%{?_scl_root}/usr/lib64 -L%{?_scl_root}/usr/lib"

%if %{with autoconf_enables_emacs}
export EMACS=%{_bindir}/emacs
%else
export EMACS=%{_bindir}/false
%endif
%configure \
    %{?with_autoconf_enables_emacs:--with-lispdir=%{_emacs_sitelispdir}/autoconf}
make %{?_smp_mflags}

#---------------------------------------------------------------------------------
%check
%if %{with check}
# make check # TESTSUITEFLAGS='1-198 200-' # will disable nr. 199.
# make check TESTSUITEFLAGS="-k \!erlang"
make check %{?_smp_mflags}
%endif

%install

make install %{?_smp_mflags} DESTDIR=%{buildroot}
mkdir -p %{buildroot}%{_datadir}
install -m 0644 %{SOURCE1} %{buildroot}%{_datadir}

%if %{with autoconf_enables_emacs}
# Create file to activate Emacs modes as required
mkdir -p %{buildroot}%{_prefix}%{_emacs_sitestartdir}
install -p -m 0644 %{SOURCE2} %{buildroot}%{_emacs_sitestartdir}
%endif
#---------------------------------------------------------------------------------

%files
%license COPYING*
%{_bindir}/*
## %{_infodir}/autoconf.info*
# don't include standards.info, because it comes from binutils...
## %exclude %{_infodir}/standards*
#  don't include info's TOP directory
## %exclude %{_infodir}/dir
%{_datadir}/autoconf/
%{_datadir}/config.site
%if %{with autoconf_enables_emacs}
%{_datadir}/emacs/site-lisp/*
%endif
%{_mandir}/man1/*

#---------------------------------------------------------------------------------

%changelog
* Fri Jul 19 2024 mgb01105731  <mgb01105731@alibaba-inc.com> - 2.69-1
- Init 2.69

